<?php

	namespace aidSQL\parser{

		class DbXml{

			private	$_xmlFile	=	NULL;
			private	$_logger		=	NULL;

			public function __construct($xmlDbFile=NULL,\aidSQL\core\Logger &$log=NULL){

		
				$this->_xmlFile		=	new \aidSQL\core\File($xmlDbFile);
				$this->setLog($log);


			}

			public function setLog(\aidSQL\core\Logger &$log=NULL){

				$this->_logger	=	$log;

			}

			public function getLog(){

				return $this->_logger;

			}

			private function log($msg=NULL, $color="white", $level=0){

				if (is_null($this->_logger)) {

					return FALSE;

				}

				$this->_logger->setPrepend('[' . __CLASS__ . ']');
				$this->_logger->log($msg, $color, $level, $toFile);

				return TRUE;

			}

			public function getPluginDetails(){

				$dom	=	new \DomDocument("1.0");
				$dom->load($this->_xmlFile->getFile());

				$pluginDetails	=	$dom->getElementsByTagName("plugin-details")->item(0)->childNodes;

				$details			=	Array();

				foreach($pluginDetails as $detail){

					$nodeName		=	$detail->nodeName;
					$detailChilds	=	$detail->childNodes;

					foreach($detailChilds as $detailChild){

						if(sizeof($detailChild->childNodes)>0){

							$details[$nodeName][$detailChild->nodeName]	=	$detailChild->nodeValue;

						}else{

							$details[$nodeName]	=	$detailChild->nodeValue;

						}

					}

				}

				return $details;

			}

			public function getVulnerableUri(){

				$dom	=	new \DomDocument("1.0");
				$dom->load($this->_xmlFile->getFile());

				return $dom->getElementsByTagName("vulnlink")->item(0)->nodeValue;

			}

			public function getHttpMethod(){

				$dom	=	new \DomDocument("1.0");
				$dom->load($this->_xmlFile->getFile());

				return $dom->getElementsByTagName("http-method")->item(0)->nodeValue;

			}

			public function getInjectionParameters(){

				$dom	=	new \DomDocument("1.0");
				$dom->load($this->_xmlFile->getFile());

				$domInjection	=	$dom->getElementsByTagName("injection")->item(0)->childNodes;

				$injection		=	Array();

				foreach($domInjection as $inject){

					$nodeName		=	$inject->nodeName;
					$injectChilds	=	$inject->childNodes;

					foreach($injectChilds as $injectChild){

						if(sizeof($injectChild->childNodes)>0){

							$injection[$nodeName][$injectChild->nodeName]	=	$injectChild->nodeValue;

						}else{

							$injection[$nodeName]	=	$injectChild->nodeValue;

						}

					}

				}

				return $injection;

			}

			public function getSchemas(){

				$dom	=	new \DomDocument("1.0");
				$dom->load($this->_xmlFile->getFile());

				$schemas			=	$dom->getElementsByTagName("schemas")->item(0)->childNodes;

				if(!$schemas->length){

					return FALSE;

				}

				foreach($schemas as $schema){

					$schemaName	=	$schema->getAttribute("name");
					$schemasArray[$schemaName]	=	array();
					$tables							=	$schema->getElementsByTagName("table");

					foreach($tables as $table){

						$tableAttributes	=	array();
						$i						=	0;

						$tablesArray		=	array();

						while($table->attributes->item($i)){

							$name							=	$table->attributes->item($i)->name;
							$value						=	$table->attributes->item($i++)->value;

							$tableAttributes[$name]	=	$value;

						}

						$tableName	=	$tableAttributes["name"];
						unset($tableAttributes["name"]);
					
						$this->log("Added table $tableName");

						$tablesArray["attributes"]	=	$tableAttributes;

						$columns			=	$table->childNodes;
						$columnsArray	=	array();

						foreach($columns as $column){

							$colName	=	$column->getAttribute("name");
							$columnsArray[$colName]	=	array();
							$colChilds	=	$column->childNodes;
							
							foreach($colChilds as $colChild){
								$columnsArray[$colName][$colChild->nodeName]	=	$colChild->nodeValue;
							}

							$tablesArray["columns"]	=	$columnsArray;

						}

						$schemasArray[$schemaName][$tableName]	=	$tablesArray;

					}

					

				}

				return $schemasArray;

			}			

		}

	}


?>
