<?php

	namespace aidSQL\parser{

		class Regex implements ParserInterface {

			private	$_regexes	=	Array();
			private	$_logger		=	NULL;

			public function cleanup(){

				$this->_regexes	=	Array();
			
			}

			public function addRegex($regex,$quote=TRUE){

				if($quote){

					$regex				=	preg_quote(trim($regex),'#');

				}

				$this->_regexes[]	=	"#$regex#";

			}

			public function setLog(\aidSQL\core\Logger &$log){

				$this->_logger	=	$log;

			}

			public function log($msg = NULL,$color="white",$type="0"){

				if(!is_null($this->_logger)){

					$this->_logger->setPrepend("[".get_class($this)."]");
					$this->_logger->log($msg,$color,$type);

					return TRUE;

				}

				return FALSE;

			}


			//In this case, this parser returns always FALSE since the only thing it does is 
			//informing about a regular expression match 

			public function analyze($content){

				if(!sizeof($this->_regexes)){

					throw(new \Exception("Can't analyze content because no REGEX has been set"));

				}

				foreach($this->_regexes as $regex){
			
					$this->log("Analyzing regex $regex ...",0,"light_purple");	

					if(preg_match($regex,$content)){

						$this->log("FOUND $regex! ...",0,"light_cyan");

						return TRUE;

					}


				}

				return FALSE;

			}

		}

	}

?>
